unit TestComponent;

{
This tiny component is only to show, how to handle
classes as properties. You know them from properties
that have a '+' in front of their names. (f.Ex. '+Font')

I tried hard just to find out, that they have to descent
from TPersistent.

Feel free to use, experiment and change that code.
But you'll have to know that there is no warranty at
all neither for the component nor for the program.

Matthias 'KaosMki' Baerens 2000
kaosmaki@yahoo.com
http://www.kaosmaki.de  
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TItemsSet = (isItem1, isItem2, isItem3);
  // A class-property MUST be a descent of TPersistent!
  TParentProperty = class(TPersistent)
  private
    FSPString: String;
    FSPInteger: Integer;
    FSPBoolean: Boolean;
    FSPItemSet: TItemsSet;
  published
    property SPString: String read FSPString write FSPString;
    property SPInteger: Integer read FSPInteger write FSPInteger;
    property SPBoolean: Boolean read FSPBoolean write FSPBoolean;
    property SPItemSet: TItemsSet read FSPItemSet write FSPItemSet;
  End;
  TTestComponent = class(TComponent)
  private
    { Private-Deklarationen }
    FParentProperty: TParentProperty;
  protected
    { Protected-Deklarationen }
    Constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
    // The following procedure will be necessary with
    // properties that uses the assign methode
    Procedure SetParentProperty(ParProp: TParentProperty); virtual;
  public
    { Public-Deklarationen }
  published
    { Published-Deklarationen }
    property ParentProperty: TParentProperty read FParentProperty
                                             write SetParentProperty;
  end;

procedure Register;

implementation

Constructor TTestComponent.Create(AOwner: TComponent);
Begin
  inherited;
  FParentProperty := TParentProperty.Create;
End;

Destructor TTestComponent.Destroy;
Begin
  FParentProperty.Free;
  inherited;
End;

Procedure TTestComponent.SetParentProperty(ParProp: TParentProperty);
Begin
  FParentProperty.FSPString := ParProp.FSPString;
  FParentProperty.FSPInteger := ParProp.FSPInteger;
  FParentProperty.FSPBoolean := ParProp.FSPBoolean;
  FParentProperty.FSPItemSet := ParProp.FSPItemSet;
End;

procedure Register;
begin
  RegisterComponents('Test', [TTestComponent]);
end;

end.
